﻿using System;
using Microsoft.ML;
using ConsoleApp1ML.Model.DataModels;

class Program
{
    static void Main(string[] args)
    {
        MLContext mlContext = new MLContext();

        ITransformer mlModel = mlContext.Model.Load("MLModel.zip", out DataViewSchema inputSchema);
        var predEngine = mlContext.Model.CreatePredictionEngine<ModelInput, ModelOutput>(mlModel);

        // Create sample data to do a single prediction with it 
        ModelInput sampleData = new ModelInput
        {
            Vendor_id = "VTS",
            Rate_code = 1.0f,
            Passenger_count = 1,
            Trip_time_in_secs = 1140,
            Trip_distance = 3.75f,
            Payment_type = "CRD",
        };

        // Try a single prediction
        ModelOutput result = predEngine.Predict(sampleData);

        Console.WriteLine($"Single Prediction --> Predicted value: {result.Score}");
    }
}
